﻿Type=StaticCode
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
End Sub

Public Sub Distance(fromPoint As PointApi, toPoint As PointApi) As Float
	Dim d As Float
	d = Sqrt(Power(Abs(toPoint.x - fromPoint.x),2) + Power(Abs(toPoint.y - fromPoint.y),2))
	Return d
End Sub

Public Sub New_Point(nAngle As Float, nRadius As Float, CenterX  As Float, CenterY As Float ) As PointApi 
	Dim pt As PointApi 
    pt.x = CenterX + (nRadius) * CosD(nAngle)
    pt.Y  = CenterY - (nRadius) * SinD(nAngle)
    Return pt
End Sub

Public Sub CalcAngleD(fromPoint As PointApi, toPoint As PointApi) As Float
    Dim dirX = toPoint.X - fromPoint.X As Float
    Dim dirY = toPoint.Y - fromPoint.Y As Float
	Return ATan2D(dirY, dirX)
End Sub

Public Sub dotLine(vw As ImageView, fromPoint As PointApi, toPoint As PointApi, strokeWdt As Float, dotSpc As Float, clr As Int)
	Dim NewPt As PointApi 
	Dim stp As Int 
	Dim Angle, lng As Double
	Dim ct As Double 
	Dim cvs As Canvas
	cvs.Initialize(vw)
	Dim Obj1 As Reflector
	Obj1.Target = cvs
   	Obj1.Target = Obj1.GetField("paint")
   	Obj1.RunMethod2("setAntiAlias", True, "java.lang.boolean")	
	Angle =  90 - CalcAngleD(fromPoint, toPoint) 
	lng = Distance(fromPoint, toPoint)
	stp = lng / dotSpc
	dotSpc = lng / stp
	lng = lng + dotSpc / 4
	For ct = 0 To stp
		NewPt.x = fromPoint.x + ct * dotSpc * SinD(Angle)
    	NewPt.y = fromPoint.y + ct * dotSpc * CosD(Angle)
		cvs.drawCircle(NewPt.x, NewPt.y, strokeWdt / 2, clr, True, 0)
	Next
End Sub

Public Sub dashLine(vw As ImageView, fromPoint As PointApi, toPoint As PointApi, strokeWdt As Float, dotSpc As Float, clr As Int)
	Dim NewPt(2) As PointApi 
	Dim stp As Int 
	Dim BlankSpc As Float = 1.75	'Percent
	Dim Angle, lng As Double
	Dim ct As Double 
	Dim cvs As Canvas
	cvs.Initialize(vw)
	Dim Obj1 As Reflector
	Obj1.Target = cvs
   	Obj1.Target = Obj1.GetField("paint")
   	Obj1.RunMethod2("setAntiAlias", True, "java.lang.boolean")	
	Angle = 90 - CalcAngleD(fromPoint, toPoint) 
	lng = Distance(fromPoint, toPoint)
	If lng < dotSpc * 2.75 Then
		cvs.drawline(fromPoint.x, fromPoint.y, toPoint.x, toPoint.y, clr, strokeWdt)
		Return
	End If
	lng = lng - dotSpc
	dotSpc = dotSpc * BlankSpc
	stp = lng / dotSpc
	dotSpc = lng / stp
	lng = lng + dotSpc / 2
	For ct = 0 To lng Step dotSpc
		NewPt(0).x   = fromPoint.x + ct * SinD(Angle)
    	NewPt(0).y = fromPoint.y + ct * CosD(Angle)
		NewPt(1).x = fromPoint.x + (ct+dotSpc/BlankSpc) * SinD(Angle)
		NewPt(1).y =  fromPoint.y + (ct+dotSpc/BlankSpc) * CosD(Angle)
		cvs.drawline(NewPt(0).x, NewPt(0).y,NewPt(1).x, NewPt(1).y,clr,strokeWdt)
	Next
End Sub

Public Sub dashdotLine(vw As ImageView, fromPoint As PointApi, toPoint As PointApi, strokeWdt As Float, dotSpc As Float, clr As Int)
	Dim NewPt(3) As PointApi 
	Dim stp As Int 
	Dim BlankSpc As Float 
	Dim Angle, lng As Double
	Dim ct As Double 
	Dim cvs As Canvas
	cvs.Initialize(vw)
	Dim Obj1 As Reflector
	Obj1.Target = cvs
   	Obj1.Target = Obj1.GetField("paint")
   	Obj1.RunMethod2("setAntiAlias", True, "java.lang.boolean")	
	Angle = 90 - CalcAngleD(fromPoint, toPoint) 
	lng = Distance(fromPoint, toPoint)
	lng = lng - dotSpc 
	BlankSpc = dotSpc + strokeWdt 
	dotSpc = dotSpc + BlankSpc
	stp = lng / dotSpc
	dotSpc = lng / stp
	lng = lng - dotSpc / 2
	For ct = 0 To lng Step dotSpc
		NewPt(0).x   = fromPoint.x + ct * SinD(Angle)
    	NewPt(0).y = fromPoint.y + ct * CosD(Angle)
		NewPt(1).x = fromPoint.x + (ct + dotSpc - BlankSpc) * SinD(Angle)
		NewPt(1).y = fromPoint.y + (ct + dotSpc - BlankSpc) * CosD(Angle)
		NewPt(2).x = fromPoint.x + (ct + dotSpc - BlankSpc / 2) * SinD(Angle)
		NewPt(2).y = fromPoint.y + (ct + dotSpc - BlankSpc / 2) * CosD(Angle)
		cvs.drawline(NewPt(0).x, NewPt(0).y, NewPt(1).x, NewPt(1).y, clr, strokeWdt)
		cvs.drawCircle(NewPt(2).x, NewPt(2).y, strokeWdt / 2, clr, True, 0)
	Next
	NewPt(0).x = fromPoint.x + ct * SinD(Angle)
	NewPt(0).y = fromPoint.y + ct * CosD(Angle)
	cvs.drawline(NewPt(0).x, NewPt(0).y, toPoint.x, toPoint.y, clr, strokeWdt)
End Sub

Public Sub drawPoints(vw As ImageView, fromPoint As PointApi, Clr As Int)
	Dim cvs As Canvas
	cvs.Initialize(vw)
	Dim Obj1 As Reflector
	Obj1.Target = cvs
   	Obj1.Target = Obj1.GetField("paint")
   	Obj1.RunMethod2("setAntiAlias", True, "java.lang.boolean")	
	cvs.DrawLine(fromPoint.x, fromPoint.y - 10, fromPoint.x, fromPoint.y + 10, Clr, 1dip)
	cvs.DrawLine(fromPoint.x - 10, fromPoint.y, fromPoint.x + 10, fromPoint.y, Clr, 1dip)	
	cvs.drawCircle(fromPoint.x , fromPoint.y, 10, Clr, False, 0.5)	
End Sub

